#include <p18f2520.h>
#include <delays.h>

#pragma config OSC = INTIO67
#pragma config FCMEN = OFF
#pragma config IESO = OFF
#pragma config PWRT = ON
#pragma config BORV = 0
#pragma config BOREN = ON
#pragma config LPT1OSC = OFF
#pragma config PBADEN = OFF
#pragma config WDT = OFF
#pragma config MCLRE = ON
#pragma config CCP2MX = PORTC
#pragma config STVREN = OFF
#pragma config LVP = OFF
#pragma config XINST = OFF
#pragma config DEBUG = OFF
#pragma config CP0 = OFF
#pragma config CP1 = OFF
#pragma config CP2 = OFF
#pragma config CP3 = OFF
#pragma config CPB = OFF
#pragma config CPD = OFF
#pragma config WRT0 = OFF
#pragma config WRT1 = OFF
#pragma config WRT2 = OFF
#pragma config WRT3 = OFF
#pragma config WRTB = OFF
#pragma config WRTC = OFF
#pragma config WRTD = OFF
#pragma config EBTR0 = OFF
#pragma config EBTR1 = OFF
#pragma config EBTR2 = OFF
#pragma config EBTR3 = OFF
#pragma config EBTRB = OFF

#define CLK LATAbits.LATA0
#define Data LATAbits.LATA1
#define LED LATAbits.LATA2
#define DataIn PORTAbits.RA1

#define TRESP Delay100TCYx(1) //---TRESP=100mks---
#define TSTART Delay100TCYx(1) //---TSTART=100mks---
#define TCLKL Delay100TCYx(1) //---TCLKL=100mks---
#define TCLKH Delay100TCYx(1) //---TCLKH=100mks---
#define TDS Delay10TCYx(5) //---TDS=50mks---
#define TDATA Delay100TCYx(1) //---TDATA-TDS=100mks---
#define TWTH Delay100TCYx(1) //---TWTH=100mks---

#pragma code

char command_byte=0xB4; //---PROGRAM---
char command_byte_lrn=0xD2; //---ACTIVATE-LEARN---
char command_byte_era=0xC3; //---ERASE-ALL---
char subcommand_byte_era=0x00;
char configuration_byte=0x00;
char manufactures_code[]={0xEF,0xCD,0xAB,0x89,0x67,0x45,0x23,0x01};

void byte_send_correction_off(char byte);
void erase_all(void);
void program_mode(void);
void learn_mode(void);

void main (void)
{
 OSCTUNE=0x00;
 OSCCON=0x34;
 ADCON1=0x7F;
 LATA=0x00;
 //erase_all();
 program_mode();
// learn_mode();

 while (1)
 {
 
 }  
}

void byte_send_correction_off(char byte)
{
 char temp=byte;
 char send=0x00;

 send=temp>>0;
 Data=send; 
 CLK=1;
 Delay10TCYx(4); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 CLK=0;
 send=temp>>1;
 Delay10TCYx(3); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();

 Data=send;
 CLK=1;
 Delay10TCYx(4); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 CLK=0;
 send=temp>>2;
 Delay10TCYx(3); 
 Delay1TCY();
 Delay1TCY();

 Data=send;
 CLK=1;
 Delay10TCYx(4);
 Delay1TCY();
 Delay1TCY(); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 CLK=0;
 send=temp>>3;
 Delay10TCYx(3); 
 Delay1TCY();

 Data=send;
 CLK=1;
 Delay10TCYx(4); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 CLK=0;
 send=temp>>4;
 Delay10TCYx(3); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();

 Data=send;
 CLK=1;
 Delay10TCYx(4); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 CLK=0;
 send=temp>>5;
 Delay10TCYx(3); 
 Delay1TCY();
 Delay1TCY();

 Data=send;
 CLK=1;
 Delay10TCYx(4);
 Delay1TCY();
 Delay1TCY(); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 CLK=0;
 send=temp>>6;

 Data=send;
 CLK=1;
 Delay10TCYx(4); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 CLK=0;
 send=temp>>7;
 Delay10TCYx(3); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();

 Data=send;
 CLK=1;
 Delay10TCYx(4); 
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 Delay1TCY();
 CLK=0;
 Delay10TCYx(4); 

 Data=0;
 return;
}

void erase_all(void)
{
 	/***ERASE*ALL*ACTIVATION***/
//---CLK-set-high-waiting-for-keeloq-responce---
 TRISA=0x02;
 while(DataIn!=1)
 {
  CLK=1;
 }
 TRESP;
 CLK=0;
//---waiting-for-the-end-of-keeloq-responce---
 while(DataIn==1)
 {
  Nop();
 }
 TSTART;
 TRISA=0x00;
//---command-byte---
 byte_send_correction_off(command_byte_era);
//---subcommand-byte---
 byte_send_correction_off(subcommand_byte_era);
//---dummy-byte---
 byte_send_correction_off(manufactures_code[0]);
	//ACKNOWLEDGE
//---CLK-set-high-waiting-for-keeloq-responce---
 TRISA=0x02;
 while(DataIn!=1)
 {
  CLK=1;
 }
 TWTH;
 CLK=0;
//---waiting-for-the-end-of-keeloq-responce---
 while(DataIn==1)
 {
  Nop();
 }
 LED=1;
 Delay1KTCYx(10);
 LED=0;
 Delay1KTCYx(10); 

 return;
}


void program_mode(void)
{
 LED=0;
	/***PROGRAM*MODE***/
	/***COMMAND***REQUEST***SEQUENCE***/

//---CLK-set-high-waiting-for-keeloq-responce---
 TRISA=0x02;
 while(DataIn!=1)
 {
  CLK=1;
 }
 TRESP;
 CLK=0;
//---waiting-for-the-end-of-keeloq-responce---
 while(DataIn==1)
 {
  Nop();
 }
 TSTART;
 TRISA=0x00;
	/***DATA***SEND***SECTION***/
//---command-byte---
 byte_send_correction_off(command_byte);
//---configuration-byte---
 byte_send_correction_off(configuration_byte);
//---manufactures-code---
 byte_send_correction_off(manufactures_code[0]);
 byte_send_correction_off(manufactures_code[1]);
 byte_send_correction_off(manufactures_code[2]);
 byte_send_correction_off(manufactures_code[3]);
 byte_send_correction_off(manufactures_code[4]);
 byte_send_correction_off(manufactures_code[5]);
 byte_send_correction_off(manufactures_code[6]);
 byte_send_correction_off(manufactures_code[7]);
	/***ACKNOWLEDGE***/
//---CLK-set-high-waiting-for-keeloq-responce---
 TRISA=0x02;
 while(DataIn!=1)
 {
  CLK=1;
 }
 TWTH;
 CLK=0;
//---waiting-for-the-end-of-keeloq-responce---
 while(DataIn==1)
 {
  Nop();
 }
 LED=1; //---keeloq-has-been-configurated---
 return;
}

void learn_mode(void)
{
	/***LEARN*MODE*ACTIVATION***/
//---CLK-set-high-waiting-for-keeloq-responce---
 TRISA=0x02;
 while(DataIn!=1)
 {
  CLK=1;
 }
 TRESP;
 CLK=0;
//---waiting-for-the-end-of-keeloq-responce---
 while(DataIn==1)
 {
  Nop();
 }
 TSTART;
 TRISA=0x00;
//---command-byte---
 byte_send_correction_off(command_byte_lrn);
//---dummy-byte---
 byte_send_correction_off(manufactures_code[0]);
 byte_send_correction_off(manufactures_code[1]);
	/***ACKNOWLEDGE***/
//---CLK-set-high-waiting-for-keeloq-responce---
 TRISA=0x02;
 while(DataIn!=1)
 {
  CLK=1;
 }
 TWTH;
 CLK=0;
//---waiting-for-the-end-of-keeloq-responce---
 while(DataIn==1)
 {
  Nop();
 }
 LED=1; //---keeloq-has-been-entered-learn-mode---
 TRISA=0x02;
 LED=1;
 Delay1KTCYx(10);
 LED=0;
 Delay1KTCYx(10); 
 
 return;
}